//---------------------------------------------------------------------------
#include <windows.h>
#include <dos.h>
#pragma hdrstop
#include <condefs.h>                           
#include "ULA_Plugin.h"

//---------------------------------------------------------------------------
USERES("ALP_DialUP.res");
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    return 1;
}
//---------------------------------------------------------------------------

#define EXPORT extern "C" __declspec(dllexport)

EXPORT  WINAPI GetPluginInfo(TPluginInfo *i){
  if(i->Size<sizeof(TPluginInfo)) return false;

  i->Version=258;
  i->IsText=true;
  i->PluginName="Plugin for MS Dial up";
  i->ProgName="DialUP";
  return true;
};

bool __fastcall IsDateTime(char *a){
  char *b=a;
  for(;*b&&(b-a<17);b++);
  if(!*b) return false;
  return(*(a+2)=='-')&&(*(a+5)=='-')&&(*(a+10)==' ')&&(*(a+13)==':')&&(*(a+16)==':')&&
       (*a>='0')&&(*a<='9');
};

bool __fastcall TestSecondLevel(char *a){
  if(*(a+19)!='.') return false;
  char *b=a[22]==' ' ? a+22:a+23;
  return ((*b==' ')&&(*(b+1)=='-')&&(*(b+2)==' '));
};

EXPORT bool  WINAPI TestBlock(char *begin){
  char *end=begin;
  while(*end){
     while((*end)&&(*end!='\n'))end++;
     if(*end) end++;
     if(*end)
      if(IsDateTime(begin))
        if(TestSecondLevel(begin)) return true;
     begin=end;
   };
  return false; 
};

unsigned long Index=0,size=1000,type_sz=REG_SZ,type_nd=0;
bool __fastcall FindModemRoot(char *Root){
 HKEY Key,TempKey;

 strcpy(Root,"SYSTEM\\CurrentControlSet\\Control\\Class");
 if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,Root,0,KEY_ALL_ACCESS,&Key)!=ERROR_SUCCESS){
     strcpy(Root,"System\\CurrentControlSet\\Services\\Class\\Modem");
     bool r=RegOpenKeyEx(HKEY_LOCAL_MACHINE,Root,0,KEY_ALL_ACCESS,&Key)==ERROR_SUCCESS;
     RegCloseKey(Key);
     return RegOpenKeyEx(HKEY_LOCAL_MACHINE,Root,0,KEY_ALL_ACCESS,&Key)==ERROR_SUCCESS;
   };

 Index=0;
 char SubKey[1000],ClassName[1000];

 while(RegEnumKey(Key,Index++,SubKey,200)==ERROR_SUCCESS){
   strcpy(Root,"SYSTEM\\CurrentControlSet\\Control\\Class\\");
   strcat(Root,SubKey);
   RegOpenKeyEx(HKEY_LOCAL_MACHINE,Root,0,KEY_ALL_ACCESS,&TempKey);

   ClassName[0]=0;
   size=1000;
   RegQueryValueEx(TempKey,"Class",0,&type_sz,ClassName,&size);

   RegCloseKey(TempKey);
   strupr(ClassName);
   if(!strcmp(ClassName,"MODEM")){
        RegCloseKey(Key);
        return true;
     };
 };
 RegCloseKey(Key);
 return false;
};

void __fastcall CreateFileName(char *Model,char *SubKey,char *FileName){
  GetWindowsDirectory(FileName,1024);
  strcat(FileName,"\\ModemLog_");
  strcat(FileName,Model);
  strcat(FileName,SubKey);
  strcat(FileName,".txt");
};

EXPORT void  WINAPI AutoSearch(TAutoSearchInfo* info){
char Root[1024],SubKey[1000];
if(FindModemRoot(Root)){

 HKEY RootKey,Key;
 RegOpenKeyEx(HKEY_LOCAL_MACHINE,Root,0,KEY_ALL_ACCESS,&RootKey);

 Index=0;
 while(RegEnumKey(RootKey,Index++,SubKey,200)==ERROR_SUCCESS){
   RegOpenKeyEx(RootKey,SubKey,0,KEY_ALL_ACCESS,&Key);

   size=1000;
   RegQueryValueEx(Key,"Model",0,&type_sz,info->ProgName,&size);
   size=1000;info->LogName[0]=0;
   RegQueryValueEx(Key,"LoggingPath",0,&type_sz,info->LogName,&size);
   if(!info->LogName[0]) CreateFileName(info->ProgName,SubKey,info->LogName);
   info->Enabled=0;
   size=4;
   RegQueryValueEx(Key,"Logging",0,&type_nd,(unsigned char*)&(info->Enabled),&size);

   strcpy(info->Data,Root);
   strcat(info->Data,"\\");
   strcat(info->Data,SubKey);

   info->Present=true;
   info++;
   RegCloseKey(Key);
 };
 RegCloseKey(RootKey);
 };
 info->Present=false;
};
EXPORT bool WINAPI EnableLog(TAutoSearchInfo* info){
  HKEY Key;
  if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,info->Data,0,KEY_ALL_ACCESS,&Key)!=ERROR_SUCCESS) return false;
  bool result=RegSetValueEx(Key,"Logging",0,REG_BINARY,(unsigned char*)&(info->Enabled),1)==ERROR_SUCCESS;
  if(result)
    result=RegSetValueEx(Key,"LoggingPath",0,REG_SZ,info->LogName,strlen(info->LogName)+1)==ERROR_SUCCESS;
  RegCloseKey(Key);
  return result;
};


char* __fastcall LineWithDateTime(char *a){
  if(IsDateTime(a)) return a;
  while(*a!='\n') a--;
  a++;
  return IsDateTime(a) ? a:0;
};

//07-12-1998 23:30:56.89 -
//07-12-1998 23:30:56.898 -

EXPORT unsigned long WINAPI GetDateTime(char *a){
  a=LineWithDateTime(a);
  if(!a) return 0;

  struct date d;
  struct time t;
  getdate(&d);

  d.da_mon=(unsigned int)atoi(a);a+=3;
  d.da_day=(unsigned int)atoi(a);a+=3;
  d.da_year=(unsigned int)atoi(a);a+=5;

  t.ti_hour=(unsigned int)atoi(a);a+=3;
  t.ti_min=(unsigned int)atoi(a);a+=3;
  t.ti_sec=(unsigned int)atoi(a);a+=3;

  return dostounix(&d,&t);
};

char * __fastcall GetBeginOfLine(char *i){
  while(*i!='\n')i--;
  while(!((*i==' ')&&(*(i-1)=='-')))i++;
  return i;
};

bool __fastcall MyStrCmp(char *a,char *b){
 for(;(*a)&&(*b)&&(*a==*b);a++,b++);
 return !(*b);
};

char* __fastcall FindObject(char *A,bool &fAn){
   int side=0,shift= A[24]=='-' ? 26:25;

   if(MyStrCmp(A+shift,"Dialing.")) side=1;
   if(MyStrCmp(A+shift,"Answering the call")) side=-1;
   while((*A)&&(!side))
    if(*(A++)=='\n'){
        shift= A[24]=='-' ? 26:25;
        if(MyStrCmp(A+shift,"Dialing.")) side=1;
        if(MyStrCmp(A+shift,"Answering the call")) side=-1;
      };
   fAn=side==-1;
   return side ? A:NULL;
};

char* __fastcall FindObject2(char *A,char *obj,char *end){
   if(!end) end=(char*)-1;
   while((*A)&&(end>A))
    if(*(A++)=='\n'){
        int n=A[24]=='-' ? 26:25;
        if(MyStrCmp(A+n,obj)) return A+strlen(obj)+n;
       };
   return NULL;
};


EXPORT char * WINAPI GetItem(char *A,TLogItemInfo* I){
   bool fAn,fAnN;
   char *SStat,*Connect=NULL,*Item,*NextItem=FindObject(A,fAnN);
  do{
     Item=NextItem;fAn=fAnN;             // for second step
     if(!Item) return NULL;              // end of log
     NextItem=FindObject(Item+1,fAnN);
     SStat=FindObject2(Item,"Session Statistics:",NextItem);
     Connect=FindObject2(Item,"Connection established at ",NextItem);
    } while(!(Connect && SStat));

     I->Connect=atoi(Connect);
     I->DateTime=GetDateTime(Item);
     I->Time=GetDateTime(SStat)-I->DateTime;
     I->InOut=(fAn ? 'I':'O');
     strcpy(I->Address,"IP");

     char *rd=FindObject2(SStat,"               Reads : ",NextItem);
     char *wr=FindObject2(rd,   "               Writes: ",NextItem);
     I->Send=atoi(wr);
     I->Receive=atoi(rd);
     return SStat;
};


